<?php
// Include the header file that includes the database information
include('/usr/share/flyspray/htdocs/header.php');

// First check that the current install is at least version 0.9.6
$check_ver = $fs->dbQuery("SELECT pref_value FROM flyspray_prefs WHERE pref_name = 'dateformat'");
if ($fs->dbCountRows($check_ver) > 0)
{
    $prev_ver = 'yes';
}

// Check to see if this database has been already upgraded to 0.9.7
$checkdb = $fs->dbQuery("SELECT pref_value FROM flyspray_prefs WHERE pref_name = 'fs_ver'");
if ($fs->dbCountRows($checkdb) > 0)
{
    $upgraded = 'yes';
}

if ($upgraded != 'yes' && $prev_ver == 'yes') {
    // Retrieve the database schema into a string
    $sql_file = file_get_contents('upgrade_0.9.6_to_0.9.7.' . $dbtype);

    // Separate each query
    $sql = explode(';', $sql_file);

    // Cycle through the queries and insert them into the database
    while (list($key, $val) = each($sql)) {
        $insert = $fs->dbQuery($val);
    };

    // Now create entries in the flyspray_users_in_groups table, otherwise current users will not work!
    $user_query = $fs->dbQuery("SELECT * FROM flyspray_users ORDER BY user_id ASC");
    while ($row = $fs->dbFetchArray($user_query)) {
        $insert = $fs->dbQuery("INSERT INTO flyspray_users_in_groups (user_id, group_id)  VALUES(?, ?)",
                array($row['user_id'], $row['group_in']));
    };

    // Cycle though existing projects to create PM groups for them
    $get_projects = $fs->dbQuery("SELECT project_id FROM flyspray_projects");
    while ($row = $fs->dbFetchArray($get_projects))
    {
      // Create the groups now!
        $add_group = $fs->dbQuery("INSERT INTO flyspray_groups
                                (group_name,
                                 group_desc,
                                 belongs_to_project,
                                 manage_project,
                                 view_tasks,
                                 open_new_tasks,
                                 modify_own_tasks,
                                 modify_all_tasks,
                                 view_comments,
                                 add_comments,
                                 edit_comments,
                                 delete_comments,
                                 create_attachments,
                                 delete_attachments,
                                 view_history,
                                 close_own_tasks,
                                 close_other_tasks,
                                 assign_to_self,
                                 assign_others_to_self,
                                 view_reports,
                                 group_open)
                                 VALUES( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)",
                                 array('Project Managers', 'Permission to do anything related to this project.' ,
                                       $fs->emptyToZero($row['project_id']),
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1',
                                       '1')
                                );
    }
}

?>
